sub show_netmag { 
    my (@db) = @_ ; 
    my @dbnetmag = dblookup (@db, 0, "netmag", 0, 0) ;
    my @records = dbmatches (@db, @dbnetmag, "origin_netmag", "orid" ) ; 
    my $ref = pfget($Pf, "netmag") ; 
    my @fields = @$ref ;
    my @info ;
    foreach my $record (@records) { 
	$dbnetmag[3] = $record ; 
	my @vals = dbgetv(@dbnetmag, @fields) ;
	foreach my $field (@fields) {
	    my $val = shift(@vals) ;
	    # print "   $field=$val" ;
	    push(@info, "  $field: $val\n" ) ; 
	}
	# print "\n" ;
    }
    return join("\n", @info) ;
}


sub show_record { 
    my (@db) = @_ ;
    my (@tables) = dbquery(@db, dbVIEW_TABLES) ;
    if ( @tables < 1 ) { 
	@tables = (dbquery(@db, dbTABLE_NAME) ) ; 
    }
    my @info ;
    foreach my $table (@tables) { 
	my $ref = pfget($Pf, $table) ; 
	my @fields = @$ref ;
	if ( @fields < 1 ) { 
	    @fields = dbquery(@db, dbTABLE_FIELDS) ; 
	}
	foreach my $field (@fields) { 
	    my $expr ;
	    if ( $field =~ /(.*)::(.*)/ ) { 
		$field = $1 ; 
		$expr = $2 ; 
	    } else { 
		$expr = $field ; 
	    }
	    my $val = dbex_eval (@db, $expr) ;
	    push(@info, "$field: $val" ) ;
	}
	if ( $table eq "origin" ) { 
	    push(@info, show_netmag(@db)) ; 
	}
    }
    return join("\n", @info) ;
}

1;
